#!/usr/bin/env rexx
slotDir=arg(arg())  -- note: last argument is the slotDir argument from BSF4ooRexx


sc=slotDir~scriptContext -- get the ScriptContext entry from slotDir

call dumpAllBindings '--> from prolog code (1) before adding entries', sc
   -- add the attribute "rexxStarted" to the ScriptContext's GLOBAL_SCOPE Bindings
call dumpAllBindings '--> from prolog code (2) AFTER adding entries', sc



::routine buttonClickedVegan public
  use arg slotDir                     -- fetch the slotDir argument
  auswahl = "Vegan"
  scriptContext=slotDir~scriptContext -- get the slotDir entry
  say auswahl
  /* hier Platz für Code*/
  /* @get(idAuswahl) */
  idAuswahl~text = "-->" auswahl "<--"

   xDesktop         = UNO.createDesktop()       /* get the OOo XDesktop interface to the service object  */
   xComponentLoader = xDesktop~XComponentLoader /* get XComponentLoader interface */

   url = ConvertToURL(directory() || "\CookItLikeRamsayDatenbank.ods")
   calcComponent = xComponentLoader~loadComponentFromURL(url, "_blank", 0, .UNO~noProps)

     /* get first sheet in spreadsheet */
   xSheet = calcComponent~XSpreadSheetDocument~getSheets~XIndexAccess~getByIndex(0) ~XSpreadSheet

   cell = xSheet~getCellbyPosition(1,RANDOM(10,16))
   rezept = cell~getFormula

   say rezept
   calcComponent~XModifiable~setModified(.false)
   calcComponent~dispose

   /* Folgender Block wird für die Ausführung der Browser-Aufrufe benötigt*/
    opsys3=.bsf4rexx~opSys3
    if opsys3="WIN" then  -- Windows
          command="explorer"
    else if opsys3="MAC" then  -- Mac
          command="open"
    else                       -- Linux
          command="xdg-open"

    url= "https://www.chefkoch.de/rezepte/" || rezept
    command url

  /* hier Platz für Code*/

  bDebug=.false -- change to .true to learn about the ScriptContext bindings
  if bDebug=.true then
      call dumpAllBindings '--> from buttonClickedVegan()', slotDir~scriptContext

::routine buttonClickedVegeta public
  use arg slotDir                     -- fetch the slotDir argument
  auswahl = "Vegetarisch"
  scriptContext=slotDir~scriptContext -- get the slotDir entry
  say auswahl
  /* hier Platz für Code*/

    /* @get(idAuswahl) */
    idAuswahl~text = "-->" auswahl "<--"
    xDesktop         = UNO.createDesktop()       /* get the OOo XDesktop interface to the service object  */
    xComponentLoader = xDesktop~XComponentLoader /* get XComponentLoader interface */

    url = ConvertToURL(directory() || "\CookItLikeRamsayDatenbank.ods")
    calcComponent = xComponentLoader~loadComponentFromURL(url, "_blank", 0, .UNO~noProps)

       /* get first sheet in spreadsheet */
     xSheet = calcComponent~XSpreadSheetDocument~getSheets~XIndexAccess~getByIndex(0) ~XSpreadSheet

     cell = xSheet~getCellbyPosition(1,RANDOM(2,8))
     rezept = cell~getFormula

     say rezept
     calcComponent~XModifiable~setModified(.false)
     calcComponent~dispose

     /* Folgender Block wird für die Ausführung der Browser-Aufrufe benötigt*/
     opsys3=.bsf4rexx~opSys3
     if opsys3="WIN" then  -- Windows
          command="explorer"
     else if opsys3="MAC" then  -- Mac
          command="open"
     else                       -- Linux
          command="xdg-open"

     url= "https://www.chefkoch.de/rezepte/" || rezept
     command url

  /* hier Platz für Code*/
  bDebug=.false -- change to .true to learn about the ScriptContext bindings
  if bDebug=.true then
      call dumpAllBindings '--> from buttonClickedVegeta()', slotDir~scriptContext


::routine buttonClickedNudeln public
  use arg slotDir                     -- fetch the slotDir argument
  auswahl = "Nudeln"
  scriptContext=slotDir~scriptContext -- get the slotDir entry
  say auswahl
  /* hier Platz für Code*/
  /* @get(idAuswahl) */
  idAuswahl~text = "-->" auswahl "<--"

   xDesktop         = UNO.createDesktop()       /* get the OOo XDesktop interface to the service object  */
   xComponentLoader = xDesktop~XComponentLoader /* get XComponentLoader interface */


   url = ConvertToURL(directory() || "\CookItLikeRamsayDatenbank.ods")
   calcComponent = xComponentLoader~loadComponentFromURL(url, "_blank", 0, .UNO~noProps)

      /* get first sheet in spreadsheet */
   xSheet = calcComponent~XSpreadSheetDocument~getSheets~XIndexAccess~getByIndex(0) ~XSpreadSheet

   cell = xSheet~getCellbyPosition(1,RANDOM(18,24))
   rezept = cell~getFormula

   say rezept
   calcComponent~XModifiable~setModified(.false)
   calcComponent~dispose

        /* Folgender Block wird für die Ausführung der Browser-Aufrufe benötigt*/
   opsys3=.bsf4rexx~opSys3
   if opsys3="WIN" then  -- Windows
        command="explorer"
   else if opsys3="MAC" then  -- Mac
        command="open"
   else                       -- Linux
        command="xdg-open"

   url= "https://www.chefkoch.de/rezepte/" || rezept

   command url
  /* hier Platz für Code*/


  bDebug=.false -- change to .true to learn about the ScriptContext bindings
  if bDebug=.true then
      call dumpAllBindings '--> from buttonClickedNudeln()', slotDir~scriptContext


::routine buttonClickedFisch public
  use arg slotDir                     -- fetch the slotDir argument
  auswahl = "Fisch"
  scriptContext=slotDir~scriptContext -- get the slotDir entry
  say auswahl
  /* hier Platz für Code*/
  /* @get(idAuswahl) */
  idAuswahl~text = "-->" auswahl "<--"

   xDesktop         = UNO.createDesktop()       /* get the OOo XDesktop interface to the service object  */
   xComponentLoader = xDesktop~XComponentLoader /* get XComponentLoader interface */


   url = ConvertToURL(directory() || "\CookItLikeRamsayDatenbank.ods")
   calcComponent = xComponentLoader~loadComponentFromURL(url, "_blank", 0, .UNO~noProps)

      /* get first sheet in spreadsheet */
   xSheet = calcComponent~XSpreadSheetDocument~getSheets~XIndexAccess~getByIndex(0) ~XSpreadSheet

   cell = xSheet~getCellbyPosition(1,RANDOM(26,32))
   rezept = cell~getFormula

   say rezept
   calcComponent~XModifiable~setModified(.false)
   calcComponent~dispose

        /* Folgender Block wird für die Ausführung der Browser-Aufrufe benötigt*/
   opsys3=.bsf4rexx~opSys3
   if opsys3="WIN" then  -- Windows
        command="explorer"
   else if opsys3="MAC" then  -- Mac
        command="open"
   else                       -- Linux
        command="xdg-open"

   url= "https://www.chefkoch.de/rezepte/" || rezept

   command url
  /* hier Platz für Code*/


  bDebug=.false -- change to .true to learn about the ScriptContext bindings
  if bDebug=.true then
      call dumpAllBindings '--> from buttonClickedNudeln()', slotDir~scriptContext


::routine buttonClickedSalat public
  use arg slotDir                     -- fetch the slotDir argument
  auswahl = "Salat"
  scriptContext=slotDir~scriptContext -- get the slotDir entry
  say auswahl
  /* hier Platz für Code*/
  /* @get(idAuswahl) */
  idAuswahl~text = "-->" auswahl "<--"

   xDesktop         = UNO.createDesktop()       /* get the OOo XDesktop interface to the service object  */
   xComponentLoader = xDesktop~XComponentLoader /* get XComponentLoader interface */


   url = ConvertToURL(directory() || "\CookItLikeRamsayDatenbank.ods")
   calcComponent = xComponentLoader~loadComponentFromURL(url, "_blank", 0, .UNO~noProps)

      /* get first sheet in spreadsheet */
   xSheet = calcComponent~XSpreadSheetDocument~getSheets~XIndexAccess~getByIndex(0) ~XSpreadSheet

   cell = xSheet~getCellbyPosition(1,RANDOM(34,40))
   rezept = cell~getFormula

   say rezept
   calcComponent~XModifiable~setModified(.false)
   calcComponent~dispose

        /* Folgender Block wird für die Ausführung der Browser-Aufrufe benötigt*/
   opsys3=.bsf4rexx~opSys3
   if opsys3="WIN" then  -- Windows
        command="explorer"
   else if opsys3="MAC" then  -- Mac
        command="open"
   else                       -- Linux
        command="xdg-open"

   url= "https://www.chefkoch.de/rezepte/" || rezept

   command url
  /* hier Platz für Code*/


  bDebug=.false -- change to .true to learn about the ScriptContext bindings
  if bDebug=.true then
      call dumpAllBindings '--> from buttonClickedNudeln()', slotDir~scriptContext


::routine buttonClickedDessert public
  use arg slotDir                     -- fetch the slotDir argument
  auswahl = "Dessert"
  scriptContext=slotDir~scriptContext -- get the slotDir entry
  say auswahl
  /* hier Platz für Code*/
  /* @get(idAuswahl) */
  idAuswahl~text = "-->" auswahl "<--"

   xDesktop         = UNO.createDesktop()       /* get the OOo XDesktop interface to the service object  */
   xComponentLoader = xDesktop~XComponentLoader /* get XComponentLoader interface */


   url = ConvertToURL(directory() || "\CookItLikeRamsayDatenbank.ods")
   calcComponent = xComponentLoader~loadComponentFromURL(url, "_blank", 0, .UNO~noProps)

      /* get first sheet in spreadsheet */
   xSheet = calcComponent~XSpreadSheetDocument~getSheets~XIndexAccess~getByIndex(0) ~XSpreadSheet

   cell = xSheet~getCellbyPosition(1,RANDOM(42,48))
   rezept = cell~getFormula

   say rezept
   calcComponent~XModifiable~setModified(.false)
   calcComponent~dispose

        /* Folgender Block wird für die Ausführung der Browser-Aufrufe benötigt*/
   opsys3=.bsf4rexx~opSys3
   if opsys3="WIN" then  -- Windows
        command="explorer"
   else if opsys3="MAC" then  -- Mac
        command="open"
   else                       -- Linux
        command="xdg-open"

   url= "https://www.chefkoch.de/rezepte/" || rezept

   command url
  /* hier Platz für Code*/


  bDebug=.false -- change to .true to learn about the ScriptContext bindings
  if bDebug=.true then
      call dumpAllBindings '--> from buttonClickedNudeln()', slotDir~scriptContext



::routine dumpAllBindings
    use strict arg title, scriptContext
    /* show the currently defined attributes in the default ScriptContext's scopes   */
    say  title 'at' pp(.dateTime~new)':'
    say
    say "getting all attributes from all ScriptContext's scopes..."
    allScopes=scriptContext~getScopes  -- there may be any number of scopes

    do scope over allScopes      -- show Bindings for each scope
        say "ScriptContext scope:" pp(scope) getScopeTitle(scope)
        bin=scriptContext~getBindings(scope)
        if bin=.nil then iterate -- inexistent scope
        minWidth=31              -- minimum width for key column
        keys=bin~keySet          -- get kay values
        it=keys~makearray        -- get the keys as a Rexx array
        do key over it~sortWith(.CaselessComparator~new) -- sort keys caselessly
           val=bin~get(key)      -- fetch the key's value
           str=" " pp(key)~left(max(minWidth,key~length+2),".")":" pp(val)
           if key="location" then str=str "~toString="pp(val~toString)
           say str
        end
        say copies("-",86)
    end
    say copies("=",86)
    return

getScopeTitle: procedure
   parse arg scopeNumber
   if      scopeNumber=100 then return "[ENGINE_SCOPE]"
   else if scopeNumber=200 then return "[GLOBAL_SCOPE]"
   return ""



::requires UNO.CLS    -- get UNO support